function A = numbering_matrix_zero(m,n)

% This function will give back the optimal tour for n and m both even, both
% odd, or one even and one odd always with radius 0; given in a matrix A.
if m == 1
    count = 1;
    A(1,1:n) = count:count+length(1:n)-1;
    
elseif mod(m,2) == 0   % If m is even and n is odd or even
    
    count = 1;
    A(1:m,1) = count:count+length(1:m)-1;
    count = count+length(1:m);
    
    for i = m:-1:1,
        if mod(i,2)==0
            A(i,2:n) = count:count+length(2:n)-1;
            count = count+length(2:n);
        else
            A(i,n:-1:2) = count:count+length(n:-1:2)-1;
            count = count+length(n:-1:2);
        end
    end
    
elseif mod(m,2) == 1 && mod(n,2) == 0 % case n is even
    
    count = 1;
    A(1:m,1) = count:count+length(1:m)-1;
    count = count+length(1:m);
    
    for i = 2:n,
        if mod(i,2)==0
            A(m:-1:2,i) = count:count+length(m:-1:2)-1;
            count = count+length(m:-1:2);
        else
            A(2:m,i) = count:count+length(2:m)-1;
            count = count+length(2:m);
        end
    end
    
    A(1,n:-1:2) = count:count+length(n:-1:2)-1;
    
elseif mod(m,2) == 1 && mod(n,2) == 1 % case both, m and n, are odd
    
    count = 1;
    A(1:m,1) = count:count+length(1:m)-1;
    count = count+length(1:m);
    
    for i = m:-1:3,
        if mod(i,2)==0
            A(i,n:-1:2) = count:count+length(n:-1:2)-1;
            count = count+length(n:-1:2);          
        else
            A(i,2:n) = count:count+length(2:n)-1;
            count = count+length(2:n);
        end
    end
    
    A(2,n:-2:3) = count:4:count+4*length(n:-2:3)-4;
    A(2,n-1:-2:2) = count+3:4:count+4*length(n-1:-2:2)-1;
    A(1,n:-2:3) = count+1:4:count+4*length(n:-2:3)-3;
    A(1,n-1:-2:2) = count+2:4:count+4*length(n-1:-2:2)-2;
    
    %count = count+4*length(n-1:-2:2)-1+1;
end